*--------------------------------------------------------------------------*
*
*	LIBLOG - Biblioteca de comunicacao com impressoras LOGGER 2.60
*			 via device driver
*
*	Data: 13/09/2002
*
*	VERSAO: 2.79 para Clipper 5.01
*
*		Atualizada com o comando para o protocolo FiscNET
*
*-------------------------------------------------------------------------*

#define		__HEXFILE__

*--- Define os retornos do device e da biblioteca --
#define	CMDOK					0
#define	CMDINVALIDO				1
#define	IMPFORADELINHA			2
#define	OCUPADODD				3
#define	CMDNAOIMPLEMENTADO		4
#define	ERROSINTAXEDD			5
#define	LIBERRTIMEOUT			6
#define	LIBERRPARAMETRO			7
#define	LIBERRBIBJAATIVA		8
#define	LIBERRBIBNAOATIVA		9
#define	LIBERRDDNAOINSTAL   	10
#define	LIBERRBANCO				11
#define	LIBERRVALOR				12
#define	LIBERREXTENSO			13
#define	LIBERRFAVOREC			14
#define	LIBERRCIDADE			15
#define LIBERRDATA				16
#define	LIBERRDESCRICAO			17
#define	LIBERRMENSAGEM			18
#define	LIBERRESPACAMENTO		19
#define	LIBERRARQUIVO			20

*--- Retornos da ProcResposta do Device
#define	RESPPRONTA			0
#define	RESPTIMEOUT			1
#define	NAOPRONTO			2
#define	TXOFFLINE			3

*--- Definicoes de uso geral
#define	TAM_MAXRESP			4096
*-----------------------------------

****** Funcoes de uso geral da biblioteca *********

*-----------------------
Function TestaLIBAtivada
*-----------------------

If Type("_LIBAtivada") == "U"
	_LIBAtivada := .f.
Endif

Return _LIBAtivada

*------------------
Function TX_Comando
Parameter Cmd
*------------------
Private TamCmd, RespDd
Private Escritos

TamCmd := Len(Cmd)
Escritos := Fwrite(_FpLIB10,Cmd,TamCmd)
If Escritos <> TamCmd .and. Ferror() <> 0
	Retorno := Ferror()
	Return -Retorno
Else
	RespDd := FreadStr(_FpLIB10,5)
	If Len(RespDd) <> 5
		Retorno := Ferror()
		Return -Retorno
	Else
		Retorno := Val(Substr(RespDd,3,2))
	Endif
Endif

Return Retorno

*-------------------
Function RX_Resposta
Parameter Resp
*-------------------
Private TamCmd, RespDd
Private Escritos

Resp := ""

TamCmd := Len(_RespostaDevice)
Escritos := Fwrite(_FpLIB10,_RespostaDevice,TamCmd)
If Escritos <> TamCmd .and. Ferror() <> 0
	Retorno := Ferror()
	Return -Retorno
Else
	RespDd := FreadStr(_FpLIB10,5)
	If Len(RespDd) <> 5
		Retorno := Ferror()
		Return -Retorno
	Else
		Retorno := Val(Substr(RespDd,3,2))
		Resp := FreadStr(_FpLIB10,TAM_MAXRESP)

		&& Retira CRs e LFs
		Resp := Strtran(Resp,Chr(10))
		Resp := Strtran(Resp,Chr(13))
	Endif
Endif

Return Retorno

*--------------------------------------
Function EnviaComando
Parameters Cmd, Parms, BytesRet, MsgRet
*--------------------------------------
Private Comando, Retorno
Private Resposta
Private Fp, Buftx, Bufrx, Bufhexa
Private i

Comando := _ComandoDevice + Cmd + Parms +  _Reservado + _FimLinha

#ifdef	__HEXFILE__
Buftx := Chr(27) + "f" + Cmd + Parms + _Reservado
Fp := Fcreate("TX.TXT",0)
If Fp >= 0
	Bufhexa := ""
	For i := 1 To Len(Buftx)
		If Asc(Substr(Buftx,i,1)) != 4		&& EOT
			Bufhexa += hexa(Asc(Substr(Buftx,i,1)),2) + " "
		Else
			Bufhexa += "00 "
		Endif
	Next
	FWrite(Fp, Bufhexa)
	FClose(Fp)
Endif
#endif

Retorno := TX_Comando(Comando)
If Retorno == CMDOK
	Retorno := NAOPRONTO
	Do While Retorno == NAOPRONTO
		Resposta := Space(BytesRet)
		Retorno := RX_Resposta(@Resposta)
	Enddo

	Do Case
		Case Retorno == RESPTIMEOUT
			Do Case
				Case Cmd == "60"	&& Comando FiscNET
					Retorno := 33
					MsgRet := Alltrim(Resposta)
			EndCase

			Retorno := LIBERRTIMEOUT

		Case Retorno == TXOFFLINE
			Retorno := IMPFORADELINHA

		Case Retorno == RESPPRONTA

#ifdef	__HEXFILE__
			Bufrx := Resposta
			Fp := Fcreate("RX.TXT",0)
			If Fp >= 0
				Bufhexa := ""
				For i := 1 To Len(Bufrx)
					Bufhexa += hexa(Asc(Substr(Bufrx,i,1)),2) + " "
				Next
				FWrite(Fp, Bufhexa)
				FClose(Fp)
			Endif
#endif

			Do Case
				Case Cmd == "04"				&& LE_REGISTRADOR: Caso especial
					Retorno := 33
					MsgRet := Alltrim(Resposta)

				Otherwise
					Retorno := Asc(Left(Resposta,1))
					MsgRet := IIF(Len(Resposta) > 1, Substr(Resposta,2,BytesRet), "")
			EndCase
	EndCase
Endif

Return Retorno

*-------------------------------
Function AlinhaParametro
Parameters Param, Tamanho, Tipo
*-------------------------------

Do Case
	Case Tipo == "C"
		Param := Left(Param+Space(Tamanho),Tamanho)

	Case Tipo == "N"
		Param := AllTrim(Param)
		Param := Right(Replicate(" ",Tamanho)+Param,Tamanho)

	Otherwise
		Param := AllTrim(Param)
EndCase

Return Param


*************************************************************


*--- Versao Biblioteca ------------------
Function LIBVer
*----------------------------------------
Return "Versao 2.79FN para Clipper 5.01"


*--- Conexao com Device -----------------
Function InitComm
*----------------------------------------
Private Retorno
Public _FpLIB10, _LIBAtivada
Public _Reservado, _FimLinha
Public _ComandoDevice, _RespostaDevice

If TestaLIBAtivada()
	Return LIBERRBIBJAATIVA
Endif

_Reservado := ""
_FimLinha  := Chr(13) + Chr(10)
_ComandoDevice  := Chr(2) + '@' + _FimLinha
_RespostaDevice := Chr(2) + 'A' + _FimLinha

_FpLIB10 := Fopen("_LOGGER_", 2)
Retorno := Ferror()

If Retorno == 0
	_LIBAtivada := .t.
	Retorno := 33				&& RESP_OK
Else
	Retorno := LIBERRDDNAOINSTAL
Endif

Return Retorno

*--- Desconexao com o Device ------------
Function EndComm
*----------------------------------------

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

Fclose(_FpLIB10)
_LIBAtivada := .f.
Return 33				// RESP_OK

*--- Testa Loop Cabo --------------------
Function LoopTest
*----------------------------------------
Private Retorno
Private Comando

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

Comando = Chr(2) + "B" + Chr(13) + Chr(10)
Retorno = TX_Comando(Comando)

Return Retorno

*--- Status Impressora ----------------------
Function StatusPrinter
*--------------------------------------------
Private Retorno, Params, SITUACAO_IMPRESSORA
Private ImpRet

ImpRet := ""
SITUACAO_IMPRESSORA := "00"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

Params := ""
Retorno := EnviaComando(SITUACAO_IMPRESSORA, Params, 1, @ImpRet)

Return Retorno

*--- Abre Gaveta de Valores -----------------
Function OpenCash
*--------------------------------------------
Private Retorno, Params, ABREGAVETA
Private ImpRet, TipoParams

ImpRet := ""
ABREGAVETA := "01"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

Params := ""

Retorno := EnviaComando(ABREGAVETA, Params, 1, @ImpRet)
Return Retorno

*--- Le Sensor ------------------------------
Function ReadSensor
Parameter pSensor
*--------------------------------------------
Private Retorno, Params, LE_SENSOR
Private ImpRet, TipoParams

ImpRet := ""
LE_SENSOR := "02"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pSensor")

If TipoParams <> "C"
	Return LIBERRPARAMETRO
Endif

If !(pSensor $ "0123456789")
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
Params := pSensor

Retorno := EnviaComando(LE_SENSOR, Params, 1, @ImpRet)
Return Retorno

*--- Avanca Linha ---------------------------
Function AdvanceLine
Parameters pNLinhas
*--------------------------------------------
Private Retorno, Params, AVANCA_LINHA
Private ImpRet, TipoParams

ImpRet := ""
AVANCA_LINHA := "03"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pNLinhas")

If TipoParams <> "C"
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
pNLinhas := AlinhaParametro(pNLinhas,2,"N")
Params := pNLinhas

Retorno := EnviaComando(AVANCA_LINHA, Params, 1, @ImpRet)
Return Retorno

*--- Le Registrador -------------------------
Function ReadRegister
Parameters pRegistrador, pValor
*--------------------------------------------
Private Retorno, Params, LE_REGISTRADOR
Private TipoParams

LE_REGISTRADOR := "04"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pRegistrador") + Type("pValor")

If TipoParams <> "CC"
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
pRegistrador := AlinhaParametro(pRegistrador,3,"N")
Params := pRegistrador

Retorno := EnviaComando(LE_REGISTRADOR, Params, 31, @pValor)
Return Retorno

*--- Venda de Item ----------------------
Function SaleItem
Parameters pCodigo, pDescricao, pQuant, ;
		   pValor, pTaxa, pUnidade, pFormato
*----------------------------------------
Private Retorno, Params, VENDA_DE_ITEM
Private ImpRet, TipoParams, TipoVenda

ImpRet := ""

TamDesc := Len(Alltrim(pDescricao))
VENDA_DE_ITEM := "05"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pCodigo") + Type("pDescricao") + Type("pQuant") + ;
			 Type("pValor") + Type("pTaxa") + Type("pUnidade") + Type("pFormato")

If TipoParams <> "CCCCCCC"
	Return LIBERRPARAMETRO
Endif

If !(pFormato $ "012")
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
pCodigo := AlinhaParametro(pCodigo,13,"N")
pDescricao := AlinhaParametro(pDescricao,62,"C")
pValor := AlinhaParametro(pValor,9,"N")
pQuant := AlinhaParametro(pQuant,7,"N")
pTaxa  := AlinhaParametro(pTaxa,2,"N")
pUnidade := AlinhaParametro(pUnidade,2,"N")

Params := pCodigo + pDescricao + pQuant + pValor + pTaxa + pUnidade + pFormato
Retorno := EnviaComando(VENDA_DE_ITEM, Params, 1, @ImpRet)

Return Retorno

*--- Cancela Venda ---------
Function CancelSale
Parameter pOperador
*---------------------------
Private Retorno, Params, CANCELA_VENDA
Private ImpRet, TipoParams

ImpRet := ""
CANCELA_VENDA := "06"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pOperador")

If TipoParams <> "C"
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
pOperador := AlinhaParametro(pOperador,8,"C")
Params := Operador

Retorno := EnviaComando(CANCELA_VENDA, Params, 1, @ImpRet)
Return Retorno

*--- Cancela Cupom ------------
Function CancelVoucher
Parameter pOperador
*------------------------------
Private Retorno, Params, CANCELA_CUPOM
Private ImpRet, TipoParams

ImpRet := ""
CANCELA_CUPOM := "07"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pOperador")

If TipoParams <> "C"
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
pOperador := AlinhaParametro(pOperador,8,"C")
Params   := Operador

Retorno := EnviaComando(CANCELA_CUPOM, Params, 1, @ImpRet)
Return Retorno


*--- Relatorio X/Z ------------------
Function PrintReport
Parameter pTipo
*------------------------------------
Private Retorno, Params, IMPRIMERELATORIO
Private ImpRet, TipoParams

ImpRet := ""
IMPRIMERELATORIO := "08"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pTipo")

If TipoParams <> "C"
	Return LIBERRPARAMETRO
Endif

If !(pTipo $ "01")
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
Params := pTipo

Retorno := EnviaComando(IMPRIMERELATORIO, Params, 1, @ImpRet)
Return Retorno

*--- Finaliza Venda --------
Function EndSale
Parameters pOper
*---------------------------
Private Retorno, Params, FINALIZA_VENDA
Private ImpRet, TipoParams

ImpRet := ""
FINALIZA_VENDA := "09"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pOper")

If TipoParams <> "C"
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
pOper := AlinhaParametro(pOper,8,"C")
Params := pOper

Retorno := EnviaComando(FINALIZA_VENDA, Params, 1, @ImpRet)
Return Retorno

*--- Pagamento -------------
Function Payment
Parameters pFrm, pDescr, ;
		   pValorPg
*---------------------------
Private Retorno, Params, PAGAMENTO
Private ImpRet, TipoParams

ImpRet := ""
PAGAMENTO := "10"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pFrm") + Type("pDescr") + Type("pValorPg")

If TipoParams <> "CCC"
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
pFrm     := AlinhaParametro(pFrm,2,"C")
pDescr   := AlinhaParametro(pDescr,10,"C")
pValorPg := AlinhaParametro(pValorPg,10,"N")
Params  := pFrm + pDescr + pValorPg

Retorno := EnviaComando(PAGAMENTO, Params, 1, @ImpRet)
Return Retorno

*--- Imprime Cliche ---------------------
Function PrintHeader
*----------------------------------------
Private Retorno, Params, IMPRIME_CABECALHO
Private ImpRet

ImpRet := ""
IMPRIME_CABECALHO := "11"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

Params := ""
Retorno := EnviaComando(IMPRIME_CABECALHO, Params, 1, @ImpRet)

Return Retorno

*--- Propaganda -----------------------------
Function ComercialText
Parameters pTexto
*--------------------------------------------
Private Retorno, Params, PROPAGANDA
Private ImpRet, TipoParams

ImpRet := ""
*PROPAGANDA := "12"
PROPAGANDA := "57"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pTexto")

If TipoParams <> "C"
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
pTexto := RTrim(pTexto)
pTexto := IIF(Len(pTexto) <> 320,Left(pTexto+Replicate(Chr(32),320),320),pTexto)
Params := pTexto

Retorno := EnviaComando(PROPAGANDA, Params, 1, @ImpRet)
Return Retorno

*--- Carga Dados Cliche -------------
Function LoadHeader
Parameters pTipoChar, pLinha1, pLinha2, ;
		   pLinha3, pLoja, pSequencia
*------------------------------------
Private Retorno, Params, CARGA_CABECALHO
Private ImpRet, TipoParams

ImpRet := ""
CARGA_CABECALHO	:= "13"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pTipoChar") + Type("pLinha1") + Type("pLinha2") + ;
			 Type("pLinha3") + Type("pLoja") + Type("pSequencia")

If TipoParams <> "CCCCCC"
	Return LIBERRPARAMETRO
Endif

If !(pTipoChar $ "01")
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
pLinha1 := IIF(Len(pLinha1) <> 40, Left(pLinha1+Space(40),40),pLinha1)
pLinha2 := AlinhaParametro(pLinha2,40,"C")
pLinha3 := AlinhaParametro(pLinha3,40,"C")
pLoja := AlinhaParametro(pLoja,3,"C")
pSequencia := AlinhaParametro(pSequencia,3,"N")
Params := pTipoChar + pLinha1 + pLinha2 + pLinha3 + pLoja + pSequencia

Retorno := EnviaComando(CARGA_CABECALHO, Params, 1, @ImpRet)
Return Retorno

*--- Identificacao Comprador ----------------
Function BuyerIdent
Parameters pComprador, pPessoa, pCGCCPF, pEndereco, ;
           pEntrega
*--------------------------------------------
Private Retorno, Params, ID_COMPRADOR
Private ImpRet, TipoParams

ImpRet := ""
ID_COMPRADOR := "14"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pComprador") + Type("pPessoa") + Type("pCGCCPF") + ;
			 Type("pEndereco") + Type("pEntrega")

If TipoParams <> "CCCCC"
	Return LIBERRPARAMETRO
Endif

If !(pPessoa $ ("FJ"))
	Return LIBERRPARAMETRO
Endif

pPessoa = IIF(pPessoa == "F", "0", "1")

*--- Alinha os parametros
pComprador := AlinhaParametro(pComprador,40,"C")
pPessoa := AlinhaParametro(pPessoa,1,"C")
pCGCCPF := AlinhaParametro(pCGCCPF,18,"C")
pEndereco := AlinhaParametro(pEndereco,40,"C")
pEntrega := AlinhaParametro(pEntrega,40,"C")
Params := pComprador + pPessoa + pCGCCPF + pEndereco + pEntrega

Retorno := EnviaComando(ID_COMPRADOR, Params, 1, @ImpRet)
Return Retorno

*--- Carrega Aliquota ---------------
Function LoadTableTax
Parameters pAliquota, pValor
*------------------------------------
Private Retorno, Params, CARGA_ALIQUOTA
Private ImpRet, TipoParams

ImpRet := ""
CARGA_ALIQUOTA := "15"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pAliquota") + Type("pValor")

If TipoParams <> "CC"
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
pAliquota := Alltrim(pAliquota)
pValor := Alltrim(pValor)

pAliquota := AlinhaParametro(pAliquota,2,"N")
pValor := AlinhaParametro(pValor,4,"N")
pAliquota := Strtran(pAliquota, " ", "0")
pValor := Strtran(pValor, " ", "0")
Params := pAliquota + pValor

Retorno := EnviaComando(CARGA_ALIQUOTA, Params, 1, @ImpRet)
Return Retorno

*--- Le Memoria Fiscal/Descompacta cupons -
Function ReadVouchers
Parameters pTipo, pInic, pFim, pModo
*------------------------------------------
Private Retorno, Params, LE_MEMORIA_FISCAL
Private ImpRet, TipoParams

ImpRet := ""
LE_MEMORIA_FISCAL := "16"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pTipo") + Type("pInic") + Type("pFim") + Type("pModo")

If TipoParams <> "CCCN"
	Return LIBERRPARAMETRO
Endif

If !(pTipo $ "0123")
	Return LIBERRPARAMETRO
Endif

If pTipo $ "03"
	pInic := Left(pInic,2) + Substr(pInic,4,2) + Right(pInic,4)
	pFim := Left(pFim,2) + Substr(pFim,4,2) + Right(pFim,4)
Else
	pInic := Right("00000000"+Alltrim(pInic),8)
	pFim := Right("00000000"+Alltrim(pFim),8)
Endif

*--- Alinha os parametros
Params := pTipo + pInic + pFim + Str(pModo,1)

Retorno := EnviaComando(LE_MEMORIA_FISCAL, Params, 1, @ImpRet)
Return Retorno

*--- Cancela Item -------------
Function CancelItem
Parameters pTransacao
*------------------------------
Private Retorno, Params, CANCELA_ITEM
Private ImpRet, TipoParams

ImpRet := ""
CANCELA_ITEM := "17"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pTransacao")

If TipoParams <> "C"
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
pTransacao := AlinhaParametro(pTransacao,3,"N")
Params    := pTransacao

Retorno := EnviaComando(CANCELA_ITEM, Params, 1, @ImpRet)
Return Retorno

*--- Acrescimos ---------------------
Function UpLiftSubTotal
Parameters pDescricao, pValor
*------------------------------------
Private Retorno, Params, ACRESCIMO
Private ImpRet, TipoParams

ImpRet := ""
ACRESCIMO := "18"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pDescricao") + Type("pValor")

If TipoParams <> "CC"
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
pDescricao := AlinhaParametro(pDescricao,10,"C")
pValor := AlinhaParametro(pValor,10,"N")
Params := "0" + pDescricao + pValor

Retorno := EnviaComando(ACRESCIMO, Params, 1, @ImpRet)
Return Retorno

*--- Desconto Subtotal --------------
Function DiscountSubTotal
Parameters pDescricao, pValor
*------------------------------------
Private Retorno, Params, DESCONTO_SUBTOTAL
Private ImpRet, TipoParams

ImpRet := ""
DESCONTO_SUBTOTAL := "19"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pDescricao") + Type("pValor")

If TipoParams <> "CC"
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
pDescricao := AlinhaParametro(pDescricao,10,"C")
pValor := AlinhaParametro(pValor,10,"N")
Params := "0" + pDescricao + pValor

Retorno := EnviaComando(DESCONTO_SUBTOTAL, Params, 1, @ImpRet)
Return Retorno

*--- Desconto de Item ---------------
Function DiscountItem
Parameters pCancela, pDescricao, pValor
*------------------------------------
Private Retorno, Params, DESCONTO_DE_ITEM
Private ImpRet, TipoParams

ImpRet := ""
DESCONTO_DE_ITEM := "20"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pCancela") + Type("pDescricao") + Type("pValor")

If TipoParams <> "CCC"
	Return LIBERRPARAMETRO
Endif

If !(pCancela $ "01")
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
pDescricao := AlinhaParametro(pDescricao,10,"C")
pValor := AlinhaParametro(pValor,9,"N")
Params := pCancela + pDescricao + pValor

Retorno := EnviaComando(DESCONTO_DE_ITEM, Params, 1, @ImpRet)
Return Retorno

*--- Atualiza Relogio -----------------------
Function ProgramClock
Parameters pAcerto, pData, pHora
*--------------------------------------------
Private Retorno, Params, ATUALIZA_RELOGIO
Private ImpRet, TipoParams

ImpRet := ""
ATUALIZA_RELOGIO := "22"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pAcerto") + Type("pData") + Type("pHora")

If TipoParams <> "CCC"
	Return LIBERRPARAMETRO
Endif

If !(pAcerto $ "012")
	Return LIBERRPARAMETRO
Endif

pData = Strtran(pData, "/")
pHora = Strtran(pHora, ":")
If Len(pHora) <> 6 .or. Len(pData) <> 8
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
Params := pAcerto + pData + pHora

Retorno := EnviaComando(ATUALIZA_RELOGIO, Params, 1, @ImpRet)
Return Retorno

*--- Cadastra Forma de Pagamento ---------------
Function LoadPayment
Parameters pForma, pDescricao
*-----------------------------------------------
Private Retorno, Params, FORMAPAGAMENTO
Private ImpRet, TipoParams

ImpRet := ""
FORMAPAGAMENTO := "23"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pForma") + Type("pDescricao")

If TipoParams <> "CC"
	Return LIBERRPARAMETRO
Endif

*--- Alinha o parametros
pForma := AlinhaParametro(pForma,2,"C")
pDescricao := AlinhaParametro(pDescricao,10,"C")
Params := pForma + pDescricao

Retorno := EnviaComando(FORMAPAGAMENTO, Params, 1, @ImpRet)
Return Retorno

*--- Cadastra Cupons nao vinculados ---------
Function LoadUnlinkVoucher
Parameters pCodigo, pDescricao, pEntrada
*--------------------------------------------
Private Retorno, Params, CUPOMNAOVINCULADO
Private ImpRet, TipoParams

ImpRet := ""
CUPOMNAOVINCULADO := "24"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pCodigo") + Type("pDescricao") + Type("pEntrada")

If TipoParams <> "CCL"
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
pCodigo := AlinhaParametro(pCodigo,2,"C")
pDescricao := AlinhaParametro(pDescricao,15,"C")
pEntrada := IIF(pEntrada, "1", "0")
Params := pCodigo + pDescricao + pEntrada

Retorno := EnviaComando(CUPOMNAOVINCULADO, Params, 1, @ImpRet)
Return Retorno

*--- Carrega Aliquota ICMS/ISS ------
Function LoadTaxes
Parameters pAliquota, pValor, pTipo
*------------------------------------
Private Retorno, Params, CARGA_ALIQS
Private ImpRet, TipoParams

ImpRet := ""
CARGA_ALIQS := "25"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pAliquota") + Type("pValor") + Type("pTipo")

If TipoParams <> "CCC"
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
pAliquota := Alltrim(pAliquota)
pValor := Alltrim(pValor)
pTipo := Left(Alltrim(pTipo),1)

pAliquota := AlinhaParametro(pAliquota,2,"N")
pValor := AlinhaParametro(pValor,4,"N")
pAliquota := Strtran(pAliquota, " ", "0")
pValor := Strtran(pValor, " ", "0")
Params := pAliquota + pValor + pTipo

Retorno := EnviaComando(CARGA_ALIQS, Params, 1, @ImpRet)
Return Retorno

*--- Espacamento entre linhas ---------------
Function LineSpacing
Parameter pTipo
*--------------------------------------------
Private Retorno, Params, ESPACO_LINHAS
Private ImpRet, TipoParams

ImpRet := ""
ESPACO_LINHAS := "26"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pTipo")

If TipoParams <> "N"
	Return LIBERRPARAMETRO
Endif

If pTipo < 0 .or. pTipo > 1		&& Longo / Curto respectivamente
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
Params := Str(pTipo,1)

Retorno := EnviaComando(ESPACO_LINHAS, Params, 1, @ImpRet)
Return Retorno

*--- Documento Vinculado p/ TEF ----------
Function TEFLinkVoucher
Parameters pSequencia, pCartao, pAutoriz,;
			pLinhas, pEspaco, pTempo
*--------------------------------------------
Private Retorno, Params, DOCVINCULADO
Private ImpRet, TipoParams

ImpRet := ""
DOCVINCULADO := "27"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pSequencia") + Type("pCartao") + Type("pAutoriz") + ;
			  Type("pLinhas") + Type("pEspaco") + Type("pTempo")

If TipoParams <> "CCCCNN"
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
pSequencia := Right("00"+Alltrim(pSequencia),2)
pCartao := AlinhaParametro(pCartao,16,"C")
pAutoriz := AlinhaParametro(pAutoriz,9,"C")
pEspaco := Str(pEspaco,2)
pTempo := Str(pTempo,2)
pLinhas := Left(pLinhas+Space(800),800)
Params := pSequencia + pCartao + pAutoriz + pLinhas + pEspaco + pTempo

Retorno := EnviaComando(DOCVINCULADO, Params, 1, @ImpRet)
Return Retorno

*--- Autentica Documento --------------------
Function Autentic
Parameter pLinha
*--------------------------------------------
Private Retorno, Params, AUTENTICA_DOCUMENTO
Private ImpRet, TipoParams

ImpRet := ""
AUTENTICA_DOCUMENTO := "29"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pLinha")

If TipoParams <> "C"
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
Params := Left(pLinha,20)

Retorno := EnviaComando(AUTENTICA_DOCUMENTO, Params, 1, @ImpRet)
Return Retorno

*--- Cupom de Stub --------------------------
Function StubVoucher
Parameter pOperador
*--------------------------------------------
Private Retorno, Params, CUPOM_STUB
Private ImpRet, TipoParams

ImpRet := ""
CUPOM_STUB := "30"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pOperador")

If TipoParams <> "C"
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
Params := pOperador

Retorno := EnviaComando(CUPOM_STUB, Params, 1, @ImpRet)
Return Retorno

*--- Imprime Cheque ------------------------------------------
Function PrintCheck
Parameters pArquivo, pValor, pFavorecido, pCidade, pData, pBanco, ;
		   pMensagem, pMoedaSing, pMoedaPlr, pMecanismo
*-------------------------------------------------------------
Private Retorno, Params, PREENCHE_CHEQUE
Private ImpRet, TipoParams
*Private XCheq[6], YCheq[10], Font[5], Quality[5]
Private XCheq[8], YCheq[14], Font[7], Quality[7]
Private X, Y, I

ImpRet := ""
PREENCHE_CHEQUE := "34"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pArquivo") + Type("pValor") + Type("pFavorecido") + ;
			 Type("pCidade") + Type("pData") + Type("pBanco") + Type("pMensagem") + ;
			 Type("pMoedaSing") + Type("pMoedaPlr") + Type("pMecanismo")

* Parametro pMecanismo opcional; se nao passado, assume mecanismo PERTO
If Type("pMecanismo") <> "N"
	pMecanismo = 1
Endif

If TipoParams <> "CCCCCCCCCN"
	Return LIBERRPARAMETRO
Endif

If pMecanismo == 1			&& PERTO
	Retorno := PLeConfigChq(pArquivo,pBanco, @XCheq, @YCheq, @Font, @Quality)
Else
	Retorno := LeConfigChq(pArquivo,pBanco, @XCheq, @YCheq)
Endif

If Retorno <> 0
	Return Retorno
Endif

*--- Alinha os parametros
pValor := AlinhaParametro(pValor,14,"N")
pFavorecido := AlinhaParametro(pFavorecido,30,"C")
pCidade := AlinhaParametro(pCidade,20,"C")
pData := Left(pData,2) + Substr(pData,4,2) + Right(pData,2)
pMensagem := AlinhaParametro(pMensagem,30,"C")
pMoedaSing := AlinhaParametro(pMoedaSing,15,"C")
pMoedaPlr := AlinhaParametro(pMoedaPlr,17,"C")

Params := ""
If pMecanismo == 1		&& PERTO
	For I := 1 to 6
		X = Right("000"+AlinhaParametro(XCheq[I],3,"X"),3)
		Y = Right("00"+AlinhaParametro(YCheq[I],2,"X"),2)
		Params := Params + X + Y
		Do Case
			Case I == 1
				Params := Params + Font[I] + Quality[I]
			Case I > 2
				Params := Params + Font[I-1] + Quality[I-1]
		Endcase
	Next

	For I := 10 To 12
		Y = Right("000"+AlinhaParametro(YCheq[I],3,"X"),3)
		Params := Params + Y
	Next

	YCheq[9] = Right("000"+AlinhaParametro(YCheq[9],3,"X"),3)

	Params := Params + pValor + pFavorecido + pCidade + pMensagem + pData + ;
					 + pMoedaSing + pMoedaPlr + YCheq[9] + "0"
Else
	For I := 1 to 6
		X = Right("00"+AlinhaParametro(XCheq[I],2,"X"),2)
		Y = Right("00"+AlinhaParametro(YCheq[I],2,"X"),2)
		Params := Params + X + Y
	Next

	For I := 8 To 10
		Y = Right("00"+AlinhaParametro(YCheq[I],2,"X"),2)
		Params := Params + Y
	Next

	YCheq[7] = Right("000"+AlinhaParametro(YCheq[7],3,"X"),3)

	Params := Params + pValor + pFavorecido + pCidade + pMensagem + pData + ;
					 + pMoedaSing + pMoedaPlr + YCheq[7]
Endif

Params := Upper(Params)
Retorno := EnviaComando(PREENCHE_CHEQUE, Params, 1, @ImpRet)
Return Retorno


*--- Imprime Cheque2 -----------------------------------------
Function PrintSlip
Parameters pArquivo, pValor, pFavorecido, pCidade, pData, pBanco, ;
		   pMensagem, pMensagem2, pMensagem3, pMoedaSing, pMoedaPlr, ;
		   pCidadePagamento, pPessoa, pBancoDestino, pAgencia, pConta, ;
		   pMecanismo
*-------------------------------------------------------------
Private Retorno, Params, PREENCHE_CHEQUE
Private ImpRet, TipoParams
*Private XCheq[6], YCheq[10], Font[5], Quality[5]
Private XCheq[8], YCheq[14], Font[7], Quality[7]
Private X, Y, I

ImpRet := ""
PREENCHE_CHEQUE := "58"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pArquivo") + Type("pValor") + Type("pFavorecido") + ;
			 Type("pCidade") + Type("pData") + Type("pBanco") + Type("pMensagem") + ;
			 Type("pMensagem2") + Type("pMensagem3") + Type("pMoedaSing") + ;
			 Type("pMoedaPlr") + Type("pCidadePagamento") + Type("pPessoa") + ;
			 Type("pBancoDestino") + Type("pAgencia") + Type("pConta") + ;
			 + Type("pMecanismo")

* Parametro pMecanismo opcional; se nao passado, assume mecanismo PERTO
If Type("pMecanismo") <> "N"
	pMecanismo = 1
Endif

If TipoParams <> "CCCCCCCCCCCCCCCCN"
	Return LIBERRPARAMETRO
Endif

If pMecanismo == 1			&& PERTO
	Retorno := PLeConfigChq(pArquivo,pBanco, @XCheq, @YCheq, @Font, @Quality)
Else
	Retorno := LeConfigChq(pArquivo,pBanco, @XCheq, @YCheq)
Endif

If Retorno <> 0
	Return Retorno
Endif

*--- Alinha os parametros
pValor := AlinhaParametro(pValor,14,"N")
pFavorecido := AlinhaParametro(pFavorecido,30,"C")
pCidade := AlinhaParametro(pCidade,20,"C")
pData := Left(pData,2) + Substr(pData,4,2) + Right(pData,2)
pMensagem := AlinhaParametro(pMensagem,30,"C")
pMensagem2 := AlinhaParametro(pMensagem2,40,"C")
pMensagem3 := AlinhaParametro(pMensagem3,20,"C")
pMoedaSing := AlinhaParametro(pMoedaSing,15,"C")
pMoedaPlr := AlinhaParametro(pMoedaPlr,17,"C")
pCidadePagamento := AlinhaParametro(pCidadePagamento,20,"C")
pPessoa := AlinhaParametro(pPessoa,50,"C")
pBancoDestino := AlinhaParametro(pBancoDestino,8,"C")
pAgencia := AlinhaParametro(pAgencia,4,"C")
pConta := AlinhaParametro(pConta,10,"C")

Params := ""
If pMecanismo == 1		&& PERTO
	For I := 1 to 8
		X = Right("000"+AlinhaParametro(XCheq[I],3,"X"),3)
		Y = Right("00"+AlinhaParametro(YCheq[I],2,"X"),2)
		Params := Params + X + Y
		Do Case
			Case I == 1
				Params := Params + Font[I] + Quality[I]
			Case I > 2
				Params := Params + Font[I-1] + Quality[I-1]
		Endcase
	Next

	For I := 10 To 12
		Y = Right("000"+AlinhaParametro(YCheq[I],3,"X"),3)
		Params := Params + Y
	Next

	YCheq[9] = Right("000"+AlinhaParametro(YCheq[9],3,"X"),3)
	YCheq[13] = Right("000"+AlinhaParametro(YCheq[13],3,"X"),3)
	YCheq[14] = Right("000"+AlinhaParametro(YCheq[14],3,"X"),3)

	Params := Params + pValor + pFavorecido + pCidade + pMensagem + pMensagem2 ;
					 + pMensagem3 + pData + pMoedaSing + pMoedaPlr + YCheq[9] + "0" ;
					 + pCidadePagamento + pPessoa + pBancoDestino + pAgencia ;
					 + YCheq[13] + pConta + YCheq[14]
Else
	For I := 1 to 6
		X = Right("00"+AlinhaParametro(XCheq[I],2,"X"),2)
		Y = Right("00"+AlinhaParametro(YCheq[I],2,"X"),2)
		Params := Params + X + Y
	Next

	For I := 10 To 12
		Y = Right("00"+AlinhaParametro(YCheq[I],2,"X"),2)
		Params := Params + Y
	Next

	YCheq[9] = Right("000"+AlinhaParametro(YCheq[9],3,"X"),3)

	Params := Params + pValor + pFavorecido + pCidade + pMensagem + pData + ;
					 + pMoedaSing + pMoedaPlr + YCheq[9]
Endif

Params := Upper(Params)
Retorno := EnviaComando(PREENCHE_CHEQUE, Params, 1, @ImpRet)
Return Retorno


*-------------------------------*
Function PLeConfigChq
Parameters Arq, Bco, X, Y, F, Q
*-------------------------------*
Private Fp, Feof, Byte
Private Estado, EstadoProx
Private Valtemp, Subestado

Private Bank
Private BancoOk, ValorOk, ExtensoOk
Private FavorecOk, CidadeOk, DataOk
Private EspacamOk, MsgOk, Msg2Ok, Msg3Ok
Private BancoAgenciaOk, ContaOk
Private NumMensagem

Private Indice23

If !File(Arq)
	Return LIBERRARQUIVO
Endif

Fp := Fopen(Arq,2)
If Ferror() <> 0
	Return LIBERRARQUIVO
Endif

*------
Store .f. To BancoOk, ValorOk, ExtensoOk, FavorecOk, CidadeOk, DataOk, ;
			 EspacamOk, MsgOk

Store "" To X[1], Y[1], X[2], Y[2], X[3], Y[3], X[4], Y[4], X[5], Y[5], X[6], Y[6], X[7], Y[7], ;
			X[8], Y[8], ;
			Y[9], Y[10], Y[11], Y[12], Y[13], Y[14]

Store "" To F[1], F[2], F[3], F[4], F[5], F[6], F[7], ;
			Q[1], Q[2], Q[3], Q[4], Q[5], Q[6], Q[7]

NumMensagem := 0		&& H tres mensagens: 1, 2 e 3
Estado := 1
Feof := .f.
Do While !Feof
	Byte := FreadStr(Fp,1)
	Feof := IIF(Byte == "", .t., .f.)
	If Feof
		Loop
	Endif
*	Estado := Maquina(Estado,Byte,Bco)

	Do Case
		Case Estado == 1
			BancoOk := .f.
			Bank := ""
			If Byte == ";"
				Estado := 18
				EstadoProx := 1
			Else
				Estado := IIF(Byte == "[", 2, 1)	&& Inicio do numero do banco
			Endif

		Case Estado == 2
			If Byte == ";"
				Estado := 18
				EstadoProx := 1
			Else
				If Byte $ "0123456789"		&& So aceita digito numerico
					Bank := Bank + Byte
				Else
					If Byte == "]"
						Estado := 3
					Else
						If Byte == "["		&& Inicio do numero do banco novamente
							BancoOk := .f.
							Bank := ""
							Estado := 2
						Else
							Estado := 1
						Endif
					Endif
				Endif

				If Estado == 3
					If Val(AllTrim(Bank)) == Val(AllTrim(Bco))	&& Se valor OK
						BancoOk := .t.							&& com o procurado:
						Estado := 3								&& Proximo estado
					Else
						Estado := 1								&& senao continua
					Endif
				Endif
			Endif

		Case Estado == 3
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte == "["				&& Nao pode reiniciar no meio da descr.
					Return LIBERRDESCRICAO
				Endif

				ValorOk := IIF(!Empty(X[1]) .and. !Empty(Y[1]) .and. !Empty(F[1]) .and. !Empty(Q[1]), .t., .f.)
				ExtensoOk := IIF(!Empty(X[2]) .and. !Empty(X[3]) .and. !Empty(Y[2]) .and. !Empty(Y[3]) .and. !Empty(F[2]) .and. !Empty(Q[2]), .t., .f.)
				FavorecOk := IIF(!Empty(X[4]) .and. !Empty(Y[4]) .and. !Empty(F[3]) .and. !Empty(Q[3]), .t., .f.)
				CidadeOk := IIF(!Empty(X[5]) .and. !Empty(Y[5]) .and. !Empty(F[4]) .and. !Empty(Q[4]), .t., .f.)
				MsgOk := IIF(!Empty(X[6]) .and. !Empty(Y[6]) .and. !Empty(F[5]) .and. !Empty(Q[5]), .t., .f.)
				Msg2Ok := IIF(!Empty(X[7]) .and. !Empty(Y[7]) .and. !Empty(F[6]) .and. !Empty(Q[6]), .t., .f.)
				Msg3Ok := IIF(!Empty(X[8]) .and. !Empty(Y[8]) .and. !Empty(F[7]) .and. !Empty(Q[7]), .t., .f.)
				EspacamOk := IIF(!Empty(Y[9]), .t., .f.)
				DataOk := IIF(!Empty(Y[10]) .and. !Empty(Y[11]) .and. !Empty(Y[12]),.t.,.f.)
				BancoAgenciaOk := IIF(!Empty(Y[13]),.t.,.f.)
				ContaOk := IIF(!Empty(Y[14]),.t.,.f.)

				If BancoOk .and. ValorOk .and. ExtensoOk .and. FavorecOk .and. CidadeOk;
				   .and. DataOk .and. EspacamOk .and. MsgOk .and. Msg2Ok .and. Msg3Ok;
				   .and. BancoAgenciaOk .and. ContaOk
					Estado := 99				&& Para sair da maquina
				Endif

				Do Case
					Case Byte == "V"		&& Coordenadas valor
						Valtemp := ""
						Subestado := 0
						Store "" To X[1], Y[1], F[1], Q[1]
						Estado := 4
					Case Byte == "E"		&& Coordenadas Extenso
						Valtemp := ""
						Subestado := 0
						Store "" To X[2], Y[2], X[3], Y[3], F[2], Q[2]
						Estado := 7
					Case Byte == "F"		&& Coordenadas Favorecido
						Valtemp := ""
						Subestado := 0
						Store "" To X[4], Y[4], F[3], Q[3]
						Estado := 12
					Case Byte == "C"		&& Coordenadas Cidade
						Valtemp := ""
						Subestado := 0
						Store "" To X[5], Y[5], F[4], Q[4]
						Estado := 15
					Case Byte == "M"		&& Coordenadas Mensagens: 1, 2 e 3
						Valtemp := ""
						Subestado := 0
						NumMensagem = NumMensagem + 1		&& 1 = Mensagem1, 2 = Mensagem 2, ...
						Store "" To X[5+NumMensagem], Y[5+NumMensagem], F[4+NumMensagem], Q[4+NumMensagem]
						Estado := 26
					Case Byte == "S"		&& Coordenadas eSpacamento
						Indice23 = 9
						Store "" To Y[9]
						Estado := 23
					Case Byte == "D"		&& Coordenadas Data
						Store "" To Y[10], Y[11], Y[12]
						Estado := 19
					Case Byte == "B"		&& Coordenadas Banco e Agencia
						Indice23 = 13
						Store "" To Y[13]
						Estado := 23
					Case Byte == "T"		&& Coordenadas Codigo da Conta
						Indice23 = 14
						Store "" To Y[14]
						Estado := 23
				EndCase
			Endif

		Case Estado == 4
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					Estado := IIF(Byte == "=", 5, 4)
				Endif
			Endif

		Case Estado == 5
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					If Byte <> " "
						If Byte $ "0123456789"
							Valtemp = Valtemp + Byte
						Else
							If Byte == ","
								Subestado++
								Do case
									Case Subestado == 1
										X[1] := Valtemp
									Case Subestado == 2
										Y[1] := Valtemp
									Case Subestado == 3
										F[1] := Valtemp
										Estado := 6
								EndCase
								Valtemp := ""
							Endif
						Endif
					Endif
				Endif
			Endif

		Case Estado == 6
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					If Byte $ "0123456789"
						Q[1] := Q[1] + Byte
					Endif
				Endif
			Endif
					





		Case Estado == 7
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					Estado := IIF(Byte == "=", 8, 7)
				Endif
			Endif

		Case Estado == 8
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					If Byte <> " "
						If Byte $ "0123456789"
							Valtemp := Valtemp + Byte
						Else
							If Byte == ","
								Subestado++
								Do Case
									Case Subestado == 1
										X[2] := Valtemp
									Case Subestado == 2
										Y[2] := Valtemp
									Case Subestado == 3
										X[3] := Valtemp
									Case Subestado == 4
										Y[3] := Valtemp
									Case Subestado == 5
										F[2] := Valtemp
										Estado := 9
								EndCase
								Valtemp := ""
							Endif
						Endif
					Endif
				Endif
			Endif

		Case Estado == 9
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					If Byte $ "0123456789"
						Q[2] := Q[2] + Byte
					Endif
				Endif
			Endif




					
		Case Estado == 12
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					Estado := IIF(Byte == "=", 13, 12)
				Endif
			Endif

		Case Estado == 13
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					If Byte <> " "
						If Byte $ "0123456789"
							Valtemp := Valtemp + Byte
						Else
							If Byte == ","
								Subestado++
								Do Case
									Case Subestado == 1
										X[4] := Valtemp
									Case Subestado == 2
										Y[4] := Valtemp
									Case Subestado == 3
										F[3] := Valtemp
										Estado := 14
								EndCase
								Valtemp := ""
							Endif
						Endif
					Endif
				Endif
			Endif

		Case Estado == 14
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					If Byte $ "0123456789"
						Q[3] := Q[3] + Byte
					Endif
				Endif
			Endif
					




		Case Estado == 15
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					Estado := IIF(Byte == "=", 16, 15)
				Endif
			Endif

		Case Estado == 16
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					If Byte <> " "
						If Byte $ "0123456789"
							Valtemp := Valtemp + Byte
						Else
							If Byte == ","
								Subestado++
								Do Case
									Case Subestado == 1
										X[5] := Valtemp
									Case Subestado == 2
										Y[5] := Valtemp
									Case Subestado == 3
										F[4] := Valtemp
										Estado := 17
								EndCase
								Valtemp := ""
							Endif
						Endif
					Endif
				Endif
			Endif

		Case Estado == 17
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					If Byte $ "0123456789"
						Q[4] := Q[4] + Byte
					Endif
				Endif
			Endif




		Case Estado == 18
			Estado := IIF(At(Byte,Chr(10)+Chr(13)) > 0, EstadoProx, 18)





		Case Estado == 19
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					Estado := IIF(Byte == "=", 20, 19)
				Endif
			Endif

		Case Estado == 20
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					If Byte <> " "
						If Byte $ "0123456789"
							Y[10] := Y[10] + Byte
						Else
							If Byte == ","
								Estado := 21
							Endif
						Endif
					Endif
				Endif
			Endif

		Case Estado == 21
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					If Byte <> " "
						If Byte $ "0123456789"
							Y[11] := Y[11] + Byte
						Else
							If Byte == ","
								Estado := 22
							Endif
						Endif
					Endif
				Endif
			Endif

		Case Estado == 22
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					If Byte $ "0123456789"
						Y[12] := Y[12] + Byte
					Endif
				Endif
			Endif

		Case Estado == 23
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					Estado := IIF(Byte == "=", 24, 23)
				Endif
			Endif

		Case Estado == 24
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					If Byte $ "0123456789"
						Y[Indice23] := Y[Indice23] + Byte
					Endif
				Endif
			Endif





		Case Estado == 26
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					Estado := IIF(Byte == "=", 27, 26)
				Endif
			Endif

		Case Estado == 27
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					If Byte <> " "
						If Byte $ "0123456789"
							Valtemp := Valtemp + Byte
						Else
							If Byte == ","
								Subestado++
								Do Case
									Case Subestado == 1
										X[5+NumMensagem] := Valtemp
									Case Subestado == 2
										Y[5+NumMensagem] := Valtemp
									Case Subestado == 3
										F[4+NumMensagem] := Valtemp
										Estado := 28
								EndCase
								Valtemp := ""
							Endif
						Endif
					Endif
				Endif
			Endif

		Case Estado == 28
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					If Byte $ "0123456789"
						Q[4+NumMensagem] := Q[4+NumMensagem] + Byte
					Endif
				Endif
			Endif

		Case Estado == 99
			Feof = .t.
	EndCase
Enddo

Fclose(Fp)

If !BancoOk
	Return LIBERRBANCO
Endif

If !ValorOk .or. Len(X[1]) > 3 .or. Len(Y[1]) > 2 .or. Len(F[1]) > 1 .or. Len(Q[1]) > 1
	Return LIBERRVALOR
Endif

If !ExtensoOk .or. Len(X[2]) > 3 .or. Len(Y[2]) > 2 .or. Len(X[3]) > 3 .or. Len(Y[3]) > 2 .or. ;
   				   Len(F[2]) > 1 .or. Len(Q[2]) > 1
	Return LIBERREXTENSO
Endif

If !FavorecOk .or. Len(X[4]) > 3 .or. Len(Y[4]) > 2 .or. Len(F[3]) > 1 .or. Len(Q[3]) > 1
	Return LIBERRFAVOREC
Endif

If !CidadeOk .or. Len(X[5]) > 3 .or. Len(Y[5]) > 2 .or. Len(F[4]) > 1 .or. Len(Q[4]) > 1
	Return LIBERRCIDADE
Endif

If !MsgOk .or. Len(X[6]) > 3 .or. Len(Y[6]) > 2 .or. Len(F[5]) > 1 .or. Len(Q[5]) > 1
	Return LIBERRMENSAGEM
Endif

If !Msg2Ok .or. Len(X[7]) > 3 .or. Len(Y[7]) > 2 .or. Len(F[6]) > 1 .or. Len(Q[6]) > 1
	Return LIBERRMENSAGEM
Endif

If !Msg3Ok .or. Len(X[8]) > 3 .or. Len(Y[8]) > 2 .or. Len(F[6]) > 1 .or. Len(Q[6]) > 1
	Return LIBERRMENSAGEM
Endif

If !EspacamOk .or. Len(Y[9]) > 3
	Return LIBERRESPACAMENTO
Endif

If !DataOk .or. Len(Y[10]) > 3 .or. Len(Y[11]) > 3 .or. Len(Y[12]) > 3
	Return LIBERRDATA
Endif

*? "BANCO    --> ["+Bank+"]"
*? "VALOR    --> Linha := ["+X[1]+"] Coluna := ["+Y[1]+"] Font := ["+F[1]+"] Quality := ["+Q[1]+"]"
*? "EXTENSO1 --> Linha := ["+X[2]+"] Coluna := ["+Y[2]+"]"
*? "EXTENSO2 --> Linha := ["+X[3]+"] Coluna := ["+Y[3]+"] Font := ["+F[2]+"] Quality := ["+Q[2]+"]"
*? "FAVOREC. --> Linha := ["+X[4]+"] Coluna := ["+Y[4]+"] Font := ["+F[3]+"] Quality := ["+Q[3]+"]"
*? "CIDADE   --> Linha := ["+X[5]+"] Coluna := ["+Y[5]+"] Font := ["+F[4]+"] Quality := ["+Q[4]+"]"
*? "MENSAGEM  --> Linha := ["+X[6]+"] Coluna := ["+Y[6]+"] Font := ["+F[5]+"] Quality := ["+Q[5]+"]"
*? "MENSAGEM2 --> Linha := ["+X[7]+"] Coluna := ["+Y[7]+"] Font := ["+F[6]+"] Quality := ["+Q[6]+"]"
*? "MENSAGEM3 --> Linha := ["+X[8]+"] Coluna := ["+Y[8]+"] Font := ["+F[7]+"] Quality := ["+Q[7]+"]"
*? "ESPACAMENTO-> Linha := ["+Y[9]+"]"
*? "DATA     --> Colunas := ["+Y[10]+","+Y[11]+","+Y[12]+"]"
*? "COLBANCO --> Coluna := ["+Y[13]+"]"
*? "COLCONTA --> Coluna := ["+Y[14]+"]"
*?
*Inkey(0)

Return 0

*-----------------------*
Function LeConfigChq
Parameters Arq, Bco, X, Y
*-----------------------*
Private Fp, Feof, Byte
Private Estado, EstadoProx

Private Bank
Private BancoOk, ValorOk, ExtensoOk
Private FavorecOk, CidadeOk, DataOk
Private EspacamOk, MsgOk

If !File(Arq)
	Return LIBERRARQUIVO
Endif

Fp := Fopen(Arq,2)
If Ferror() <> 0
	Return LIBERRARQUIVO
Endif

*------
Store .f. To BancoOk, ValorOk, ExtensoOk, FavorecOk, CidadeOk, DataOk, ;
			 EspacamOk, MsgOk

Store "" To X[1], Y[1], X[2], Y[2], X[3], Y[3], X[4], Y[4], X[5], Y[5], ;
			X[6], Y[6], ;
			Y[7], Y[8], Y[9], Y[10]

Estado := 1
Feof := .f.
Do While !Feof
	Byte := FreadStr(Fp,1)
	Feof := IIF(Byte == "", .t., .f.)
	If Feof
		Loop
	Endif
*	Estado := Maquina(Estado,Byte,Bco)

	Do Case
		Case Estado == 1
			BancoOk := .f.
			Bank := ""
			If Byte == ";"
				Estado := 18
				EstadoProx := 1
			Else
				Estado := IIF(Byte == "[", 2, 1)	&& Inicio do numero do banco
			Endif

		Case Estado == 2
			If Byte == ";"
				Estado := 18
				EstadoProx := 1
			Else
				If Byte $ "0123456789"		&& So aceita digito numerico
					Bank := Bank + Byte
				Else
					If Byte == "]"
						Estado := 3
					Else
						If Byte == "["		&& Inicio do numero do banco novamente
							BancoOk := .f.
							Bank := ""
							Estado := 2
						Else
							Estado := 1
						Endif
					Endif
				Endif

				If Estado == 3
					If Val(AllTrim(Bank)) == Val(AllTrim(Bco))	&& Se valor OK
						BancoOk := .t.							&& com o procurado:
						Estado := 3								&& Proximo estado
					Else
						Estado := 1								&& senao continua
					Endif
				Endif
			Endif

		Case Estado == 3
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte == "["				&& Nao pode reiniciar no meio da descr.
					Return LIBERRDESCRICAO
				Endif

				ValorOk := IIF(!Empty(X[1]) .and. !Empty(Y[1]), .t., .f.)
				ExtensoOk := IIF(!Empty(X[2]) .and. !Empty(X[3]) .and. !Empty(Y[2]) .and. !Empty(Y[3]), .t., .f.)
				FavorecOk := IIF(!Empty(X[4]) .and. !Empty(Y[4]), .t., .f.)
				CidadeOk := IIF(!Empty(X[5]) .and. !Empty(Y[5]), .t., .f.)
				MsgOk := IIF(!Empty(X[6]) .and. !Empty(Y[6]), .t., .f.)
				EspacamOk := IIF(!Empty(Y[7]), .t., .f.)
				DataOk := IIF(!Empty(Y[8]) .and. !Empty(Y[9]) .and. !Empty(Y[10]),.t.,.f.)

				If BancoOk .and. ValorOk .and. ExtensoOk .and. FavorecOk .and. CidadeOk;
				   .and. DataOk .and. EspacamOk .and. MsgOk
					Estado := 99				&& Para sair da maquina
				Endif

				Do Case
					Case Byte == "V"		&& Coordenadas valor
						Store "" To X[1], Y[1]
						Estado := 4
					Case Byte == "E"		&& Coordenadas Extenso
						Store "" To X[2], Y[2], X[3], Y[3]
						Estado := 7
					Case Byte == "F"		&& Coordenadas Favorecido
						Store "" To X[4], Y[4]
						Estado := 12
					Case Byte == "C"		&& Coordenadas Cidade
						Store "" To X[5], Y[5]
						Estado := 15
					Case Byte == "M"		&& Coordenadas Mensagem
						Store "" To X[6], Y[6]
						Estado := 26
					Case Byte == "S"		&& Coordenadas eSpacamento
						Store "" To Y[7]
						Estado := 23
					Case Byte == "D"		&& Coordenadas Data
						Store "" To Y[8], Y[9], Y[10]
						Estado := 19
				EndCase
			Endif

		Case Estado == 4
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					Estado := IIF(Byte == "=", 5, 4)
				Endif
			Endif

		Case Estado == 5
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					If Byte <> " "
						If Byte $ "0123456789"
							X[1] := X[1] + Byte
						Else
							If Byte == ","
								Estado := 6
							Endif
						Endif
					Endif
				Endif
			Endif

		Case Estado == 6
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					If Byte $ "0123456789"
						Y[1] := Y[1] + Byte
					Endif
				Endif
			Endif
					
		Case Estado == 7
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					Estado := IIF(Byte == "=", 8, 7)
				Endif
			Endif

		Case Estado == 8
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					If Byte <> " "
						If Byte $ "0123456789"
							X[2] := X[2] + Byte
						Else
							If Byte == ","
								Estado := 9
							Endif
						Endif
					Endif
				Endif
			Endif

		Case Estado == 9
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					If Byte <> " "
						If Byte $ "0123456789"
							Y[2] := Y[2] + Byte
						Else
							If Byte == ","
								Estado := 10
							Endif
						Endif
					Endif
				Endif
			Endif

		Case Estado == 10
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					If Byte <> " "
						If Byte $ "0123456789"
							X[3] := X[3] + Byte
						Else
							If Byte == ","
								Estado := 11
							Endif
						Endif
					Endif
				Endif
			Endif

		Case Estado == 11
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					If Byte $ "0123456789"
						Y[3] := Y[3] + Byte
					Endif
				Endif
			Endif
					
		Case Estado == 12
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					Estado := IIF(Byte == "=", 13, 12)
				Endif
			Endif

		Case Estado == 13
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					If Byte <> " "
						If Byte $ "0123456789"
							X[4] := X[4] + Byte
						Else
							If Byte == ","
								Estado := 14
							Endif
						Endif
					Endif
				Endif
			Endif

		Case Estado == 14
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					If Byte $ "0123456789"
						Y[4] := Y[4] + Byte
					Endif
				Endif
			Endif
					
		Case Estado == 15
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					Estado := IIF(Byte == "=", 16, 15)
				Endif
			Endif

		Case Estado == 16
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					If Byte <> " "
						If Byte $ "0123456789"
							X[5] := X[5] + Byte
						Else
							If Byte == ","
								Estado := 17
							Endif
						Endif
					Endif
				Endif
			Endif

		Case Estado == 17
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					If Byte $ "0123456789"
						Y[5] := Y[5] + Byte
					Endif
				Endif
			Endif

		Case Estado == 18
			Estado := IIF(At(Byte,Chr(10)+Chr(13)) > 0, EstadoProx, 18)

		Case Estado == 19
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					Estado := IIF(Byte == "=", 20, 19)
				Endif
			Endif

		Case Estado == 20
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					If Byte <> " "
						If Byte $ "0123456789"
							Y[8] := Y[8] + Byte
						Else
							If Byte == ","
								Estado := 21
							Endif
						Endif
					Endif
				Endif
			Endif

		Case Estado == 21
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					If Byte <> " "
						If Byte $ "0123456789"
							Y[9] := Y[9] + Byte
						Else
							If Byte == ","
								Estado := 22
							Endif
						Endif
					Endif
				Endif
			Endif

		Case Estado == 22
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					If Byte $ "0123456789"
						Y[10] := Y[10] + Byte
					Endif
				Endif
			Endif

		Case Estado == 23
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					Estado := IIF(Byte == "=", 24, 23)
				Endif
			Endif

		Case Estado == 24
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					If Byte $ "0123456789"
						Y[7] := Y[7] + Byte
					Endif
				Endif
			Endif





		Case Estado == 26
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					Estado := IIF(Byte == "=", 27, 26)
				Endif
			Endif

		Case Estado == 27
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					If Byte <> " "
						If Byte $ "0123456789"
							X[6] := X[6] + Byte
						Else
							If Byte == ","
								Estado := 28
							Endif
						Endif
					Endif
				Endif
			Endif

		Case Estado == 28
			If Byte == ";"
				Estado := 18
				EstadoProx := 3
			Else
				If Byte $ (Chr(10)+Chr(13))
					Estado := 3
				Else
					If Byte $ "0123456789"
						Y[6] := Y[6] + Byte
					Endif
				Endif
			Endif

		Case Estado == 99
			Feof = .t.
	EndCase
Enddo

Fclose(Fp)

If !BancoOk
	Return LIBERRBANCO
Endif

If !ValorOk .or. Len(X[1]) > 2 .or. Len(Y[1]) > 2
	Return LIBERRVALOR
Endif

If !ExtensoOk .or. Len(X[2]) > 2 .or. Len(Y[2]) > 2 .or. Len(X[3]) > 2 .or. Len(Y[3]) > 2
	Return LIBERREXTENSO
Endif

If !FavorecOk .or. Len(X[4]) > 2 .or. Len(Y[4]) > 2
	Return LIBERRFAVOREC
Endif

If !CidadeOk .or. Len(X[5]) > 2 .or. Len(Y[5]) > 2
	Return LIBERRCIDADE
Endif

If !MsgOk .or. Len(X[6]) > 2 .or. Len(Y[6]) > 2
	Return LIBERRMENSAGEM
Endif

If !EspacamOk .or. Len(Y[7]) > 2
	Return LIBERRESPACAMENTO
Endif

If !DataOk .or. Len(Y[8]) > 2 .or. Len(Y[9]) > 2 .or. Len(Y[10]) > 2
	Return LIBERRDATA
Endif

*? "BANCO    --> ["+Bank+"]"
*? "VALOR    --> Linha := ["+X[1]+"] Coluna := ["+Y[1]+"]"
*? "EXTENSO1 --> Linha := ["+X[2]+"] Coluna := ["+Y[2]+"]"
*? "EXTENSO2 --> Linha := ["+X[3]+"] Coluna := ["+Y[3]+"]"
*? "FAVOREC. --> Linha := ["+X[4]+"] Coluna := ["+Y[4]+"]"
*? "CIDADE   --> Linha := ["+X[5]+"] Coluna := ["+Y[5]+"]"
*? "MENSAGEM  --> Linha := ["+X[6]+"] Coluna := ["+Y[6]+"]"
*? "ESPACAMENTO-> Linha := ["+Y[7]+"]"
*? "DATA     --> Colunas := ["+Y[8]+","+Y[9]+","+Y[10]+"]"
*?

Return 0


*--- Novo Proprietario --------------
Function LoadFieldsMF
Parameters pCGC, pInscEst, pInscMun
*------------------------------------
Private Retorno, Params, CAMPOS_MEMFISCAL
Private ImpRet, TipoParams

ImpRet := ""
CAMPOS_MEMFISCAL := "35"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pCGC") + Type("pInscEst") + Type("pInscMun")

If TipoParams <> "CCC"
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
pCGC := AlinhaParametro(pCGC,18,"C")
pInscEst := AlinhaParametro(pInscEst,15,"C")
pInscMun := AlinhaParametro(pInscMun,15,"C")
Params := pCGC + pInscEst + pInscMun

Retorno := EnviaComando(CAMPOS_MEMFISCAL, Params, 1, @ImpRet)
Return Retorno

*--- Documento Vinculado p/ Cartao Credito-----
Function CardLinkVoucher
Parameters pSequencia, pCartao, pValidade, ;
           pAutorizacao, pLinhas, pEspaco, pTempo
*-----------------------------------------------
Private Retorno, Params, DOCVINCULADO
Private ImpRet, TipoParams

ImpRet := ""
DOCVINCULADO := "36"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pSequencia") + Type("pCartao") + Type("pValidade") + ;
			  Type("pAutorizacao") + Type("pLinhas") + Type("pEspaco") + ;
			  Type("pTempo")

If TipoParams <> "CCCCCNN"
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
pSequencia := Right("00"+Alltrim(pSequencia),2)
pCartao := AlinhaParametro(pCartao,16,"C")
pValidade := AlinhaParametro(pValidade,4,"C")
pAutorizacao := AlinhaParametro(pAutorizacao,9,"C")
pEspaco := Str(pEspaco,2)
pTempo := Str(pTempo,2)
pLinhas := Left(pLinhas+Space(800),800)
Params := pSequencia + pCartao + pValidade + pAutorizacao + pLinhas + pEspaco +;
		  pTempo

Retorno := EnviaComando(DOCVINCULADO, Params, 1, @ImpRet)
Return Retorno


*--- Configura Tipo de Mecanismo Impressor --
Function PrinterModel
Parameter pTipo
*--------------------------------------------
Private Retorno, Params, TIPOMECANISMO
Private ImpRet, TipoParams

ImpRet := ""
TIPOMECANISMO := "39"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pTipo")

If TipoParams <> "N"
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
Params := Chr(pTipo)

Retorno := EnviaComando(TIPOMECANISMO, Params, 1, @ImpRet)
Return Retorno

*--- Imprime Item nao vinculado -------------
Function PrintUnlinkItem
Parameters pForma, pDescricao, pValor
*--------------------------------------------
Private Retorno, Params, IMPRIMENAOVINCULADO
Private ImpRet, TipoParams

ImpRet := ""
IMPRIMENAOVINCULADO := "42"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pForma") + Type("pDescricao") + Type("pValor")

If TipoParams <> "CCC"
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
pForma := AlinhaParametro(pForma,2,"C")
pDescricao := AlinhaParametro(pDescricao,20,"C")
pValor := AlinhaParametro(pValor,9,"N")
Params := pForma + pDescricao + pValor

Retorno := EnviaComando(IMPRIMENAOVINCULADO, Params, 1, @ImpRet)
Return Retorno

*--- Emite vinculado -----------------
Function NLinkVoucher
Parameters pCOO, pItem, pNome
*-------------------------------------
Private Retorno, Params, NOVOVINCULADO
Private ImpRet, TipoParams

ImpRet := ""
NOVOVINCULADO := "44"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pCOO") + Type("pItem") + Type("pNome")

If TipoParams <> "CCC"
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
pCOO  := AlinhaParametro(pCOO,6,"N")
pItem := Right("00"+Alltrim(pItem),2)
pNome := AlinhaParametro(pNome,20,"C")
Params := pCOO + pItem + pNome

Retorno := EnviaComando(NOVOVINCULADO, Params, 1, @ImpRet)
Return Retorno


*--- Encerra relatorio gerencial -----------
Function CloseReport
*--------------------------------------------
Private Retorno, Params, ENCERRARELATORIO
Private ImpRet, TipoParams

ImpRet := ""
ENCERRARELATORIO := "45"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

*--- Alinha os parametros
Params := ""

Retorno := EnviaComando(ENCERRARELATORIO, Params, 1, @ImpRet)
Return Retorno


*--- Auto Cutter ---------------------------
Function AutoCutter
*--------------------------------------------
Private Retorno, Params, CORTAPAPEL
Private ImpRet, TipoParams

ImpRet := ""
CORTAPAPEL := "46"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

*--- Alinha os parametros
Params := ""

Retorno := EnviaComando(CORTAPAPEL, Params, 1, @ImpRet)
Return Retorno

*--- Leitura CMC7 p/ buffer ECF ------------
Function ReadCMC7ToBuf
*--------------------------------------------
Private Retorno, Params, LEITURACMC7
Private ImpRet, TipoParams

ImpRet := ""
LEITURACMC7 := "47"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

*--- Alinha os parametros
Params := ""

Retorno := EnviaComando(LEITURACMC7, Params, 1, @ImpRet)
Return Retorno

*--- Linhas Livres -------------------------
Function FreeLines
Parameters pTamanho, pTexto
*--------------------------------------------
Private Retorno, Params, LINHASLIVRES
Private ImpRet, TipoParams

ImpRet := ""
LINHASLIVRES := "48"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pTamanho") + Type("pTexto")

If TipoParams <> "CC"
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
pTamanho := AlinhaParametro(pTamanho,3,"N")
pTexto := AlinhaParametro(pTexto,410,"C")
Params := pTamanho + pTexto

Retorno := EnviaComando(LINHASLIVRES, Params, 1, @ImpRet)
Return Retorno

*--- Expulsa Cheque ------------------------
Function EjectCheck
*--------------------------------------------
Private Retorno, Params, EJECTCHECK
Private ImpRet, TipoParams

ImpRet := ""
EJECTCHECK := "49"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

*--- Alinha os parametros
Params := ""

Retorno := EnviaComando(EJECTCHECK, Params, 1, @ImpRet)
Return Retorno

*--- Documento Vinculado -------------------------
Function LinkVoucher
Parameters pItem, pDoc, pAutoriz, pNome, pVias, ;
           pLinhas, pSalto, pTmpDestaque
*-------------------------------------------------
Private Retorno, Params, VINCULADOGERAL
Private ImpRet, TipoParams

ImpRet := ""
VINCULADOGERAL := "50"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pItem") + Type("pDoc") + Type("pAutoriz") + Type("pNome") + ;
			  Type("pVias") + Type("pLinhas") + Type("pSalto") + ;
			  Type("pTmpDestaque")

If TipoParams <> "CCCCCCNN"
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
pItem := Right("00"+Alltrim(pItem),2)
pDoc := AlinhaParametro(pDoc,16,"C")
pAutoriz := AlinhaParametro(pAutoriz,9,"C")
pNome := AlinhaParametro(pNome,20,"C")
pVias := AlinhaParametro(pVias,1,"C")
pSalto := Str(pSalto,2)
pTmpDestaque := Str(pTmpDestaque,2)
pLinhas := Left(pLinhas+Space(800),800)
Params := pItem + pDoc + pAutoriz + pNome + pVias + pLinhas + pSalto +;
		  pTmpDestaque

Retorno := EnviaComando(VINCULADOGERAL, Params, 1, @ImpRet)
Return Retorno


*--- Area de Rascunho ----------------------------
Function StoreText
Parameter pTexto
*-------------------------------------------------
Private Retorno, Params, AREARASCUNHO
Private ImpRet, TipoParams

ImpRet := ""
AREARASCUNHO := "51"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pTexto")

If TipoParams <> "C"
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
pTexto := AlinhaParametro(pTexto,30,"C")
Params := pTexto

Retorno := EnviaComando(AREARASCUNHO, Params, 1, @ImpRet)
Return Retorno

*--- Ajuste de Contraste de Impressao: Termica ---
Function PrinterContrast
Parameter pValor
*-------------------------------------------------
Private Retorno, Params, CONTRASTETERMICO
Private ImpRet, TipoParams

ImpRet := ""
CONTRASTETERMICO := "52"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pValor")

If TipoParams <> "C"
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
pValor := AlinhaParametro(pValor,1,"C")
Params := pValor

Retorno := EnviaComando(CONTRASTETERMICO, Params, 1, @ImpRet)
Return Retorno


*--- Cruzamento de Cheques -----------------------
Function CrossCheck
Parameter pTipo, pLinha1, pLinha2, pLinha3
*-------------------------------------------------
Private Retorno, Params, CRUZAMENTOCHEQUE
Private ImpRet, TipoParams

ImpRet := ""
CRUZAMENTOCHEQUE := "54"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pTipo") + Type("pLinha1") + Type("pLinha2") + Type("pLinha3")

If TipoParams <> "CCCC"
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
pTipo := AlinhaParametro(pTipo,1,"C")
pLinha1 := AlinhaParametro(pLinha1,15,"C")
pLinha2 := AlinhaParametro(pLinha2,15,"C")
pLinha3 := AlinhaParametro(pLinha3,15,"C")
Params := pTipo + pLinha1 + pLinha2 + pLinha3

Retorno := EnviaComando(CRUZAMENTOCHEQUE, Params, 1, @ImpRet)
Return Retorno

*--- Chancela Cheque -----------------------------
Function Chancela
Parameter pLinha, pColuna, pTexto
*-------------------------------------------------
Private Retorno, Params, CHANCELACHEQUE
Private ImpRet, TipoParams

ImpRet := ""
*CHANCELACHEQUE := "55"
CHANCELACHEQUE := "59"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pLinha") + Type("pColuna") + Type("pTexto")

If TipoParams <> "CCC"
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
pLinha  := AlinhaParametro(pLinha,2,"C")
pColuna := AlinhaParametro(pColuna,3,"C")
pTexto  := AlinhaParametro(pTexto,18,"C")
Params  := pLinha + pColuna + pTexto

Retorno := EnviaComando(CHANCELACHEQUE, Params, 1, @ImpRet)
Return Retorno

*--- Imprime Codigo de Barras --------------------
Function BarCode
Parameter pSentido, pCodigo
*-------------------------------------------------
Private Retorno, Params, CODIGODEBARRAS
Private ImpRet, TipoParams

ImpRet := ""
CODIGODEBARRAS := "56"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pSentido") + Type("pCodigo")

If TipoParams <> "CC"
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
pSentido := Left(pSentido,1)
pCodigo  := AlinhaParametro(pCodigo,40,"C")
Params  := pSentido + pCodigo

Retorno := EnviaComando(CODIGODEBARRAS, Params, 1, @ImpRet)
Return Retorno

*--- Comando FiscNET Logger II ------
Function CmdFiscNET
Parameter pComando, pRet
*------------------------------------
Private Retorno, Params, FISCNET_LOGGERII
Private ImpRet, TipoParams, TamComando

ImpRet := ""
FISCNET_LOGGERII := "60"

If !TestaLIBAtivada()
	Return LIBERRBIBNAOATIVA
Endif

TipoParams := Type("pComando") + Type("pRet")

If TipoParams <> "CC"
	Return LIBERRPARAMETRO
Endif

*--- Alinha os parametros
TamComando := Len(pComando)
TamComando := Right("0000" + Alltrim(Str(TamComando)),4)
Params := TamComando + pComando

Retorno := EnviaComando(FISCNET_LOGGERII, Params, 4096, @pRet)
Return Retorno
